import 'package:dynacode/src/keyed_archive.dart';

class ReferenceResolver {
  ReferenceResolver(this.document);

  final KeyedArchive document;

  KeyedArchive resolve(Uri? ref) {
    return ref!.pathSegments.fold(document, (objectPtr, pathSegment) {
      dynamic objectPointer = objectPtr as Map<String, dynamic>;
      return objectPointer[pathSegment] as Map<String, dynamic>;
    }) as KeyedArchive;
  }
}
